Code

Teach "git add -i" to colorize whitespace errors
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 OPTIONS_KEEPDASHDASH=
6 OPTIONS_SPEC="\
7 git-am [options] <mbox>|<Maildir>...
8 git-am [options] --resolved
9 git-am [options] --skip
10 --
11 d,dotest=       use <dir> and not .dotest
12 i,interactive   run interactively
13 b,binary        pass --allo-binary-replacement to git-apply
14 3,3way          allow fall back on 3way merging if needed
15 s,signoff       add a Signed-off-by line to the commit message
16 u,utf8          recode into utf8 (default)
17 k,keep          pass -k flagg to git-mailinfo
18 whitespace=     pass it through git-apply
19 C=              pass it through git-apply
20 p=              pass it through git-apply
21 resolvemsg=     override error message when patch failure occurs
22 r,resolved      to be used after a patch failure
23 skip            skip the current patch"
25 . git-sh-setup
26 set_reflog_action am
27 require_work_tree
29 git var GIT_COMMITTER_IDENT >/dev/null || exit
31 stop_here () {
32     echo "$1" >"$dotest/next"
33     exit 1
34 }
36 stop_here_user_resolve () {
37     if [ -n "$resolvemsg" ]; then
38             printf '%s\n' "$resolvemsg"
39             stop_here $1
40     fi
41     cmdline=$(basename $0)
42     if test '' != "$interactive"
43     then
44         cmdline="$cmdline -i"
45     fi
46     if test '' != "$threeway"
47     then
48         cmdline="$cmdline -3"
49     fi
50     if test '.dotest' != "$dotest"
51     then
52         cmdline="$cmdline -d=$dotest"
53     fi
54     echo "When you have resolved this problem run \"$cmdline --resolved\"."
55     echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
57     stop_here $1
58 }
60 go_next () {
61         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
62                 "$dotest/patch" "$dotest/info"
63         echo "$next" >"$dotest/next"
64         this=$next
65 }
67 cannot_fallback () {
68         echo "$1"
69         echo "Cannot fall back to three-way merge."
70         exit 1
71 }
73 fall_back_3way () {
74     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
76     rm -fr "$dotest"/patch-merge-*
77     mkdir "$dotest/patch-merge-tmp-dir"
79     # First see if the patch records the index info that we can use.
80     git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
81         "$dotest/patch" &&
82     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
83     git write-tree >"$dotest/patch-merge-base+" ||
84     cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
86     echo Using index info to reconstruct a base tree...
87     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
88         git apply $binary --cached <"$dotest/patch"
89     then
90         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
91         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
92     else
93         cannot_fallback "Did you hand edit your patch?
94 It does not apply to blobs recorded in its index."
95     fi
97     test -f "$dotest/patch-merge-index" &&
98     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
99     orig_tree=$(cat "$dotest/patch-merge-base") &&
100     rm -fr "$dotest"/patch-merge-* || exit 1
102     echo Falling back to patching base and 3-way merge...
104     # This is not so wrong.  Depending on which base we picked,
105     # orig_tree may be wildly different from ours, but his_tree
106     # has the same set of wildly different changes in parts the
107     # patch did not touch, so recursive ends up canceling them,
108     # saying that we reverted all those changes.
110     eval GITHEAD_$his_tree='"$SUBJECT"'
111     export GITHEAD_$his_tree
112     git-merge-recursive $orig_tree -- HEAD $his_tree || {
113             git rerere
114             echo Failed to merge in the changes.
115             exit 1
116     }
117     unset GITHEAD_$his_tree
120 reread_subject () {
121         git stripspace <"$1" | sed -e 1q
124 prec=4
125 dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
126 resolvemsg= resume=
127 git_apply_opt=
129 while test $# != 0
130 do
131         case "$1" in
132         -i|--interactive)
133                 interactive=t ;;
134         -b|--binary)
135                 binary=t ;;
136         -3|--3way)
137                 threeway=t ;;
138         -s|--signoff)
139                 sign=t ;;
140         -u|--utf8)
141                 utf8=t ;; # this is now default
142         --no-utf8)
143                 utf8= ;;
144         -k|--keep)
145                 keep=t ;;
146         -r|--resolved)
147                 resolved=t ;;
148         --skip)
149                 skip=t ;;
150         -d|--dotest)
151                 shift; dotest=$1;;
152         --resolvemsg)
153                 shift; resolvemsg=$1 ;;
154         --whitespace)
155                 git_apply_opt="$git_apply_opt $1=$2"; shift ;;
156         -C|-p)
157                 git_apply_opt="$git_apply_opt $1$2"; shift ;;
158         --)
159                 shift; break ;;
160         *)
161                 usage ;;
162         esac
163         shift
164 done
166 # If the dotest directory exists, but we have finished applying all the
167 # patches in them, clear it out.
168 if test -d "$dotest" &&
169    last=$(cat "$dotest/last") &&
170    next=$(cat "$dotest/next") &&
171    test $# != 0 &&
172    test "$next" -gt "$last"
173 then
174    rm -fr "$dotest"
175 fi
177 if test -d "$dotest"
178 then
179         case "$#,$skip$resolved" in
180         0,*t*)
181                 # Explicit resume command and we do not have file, so
182                 # we are happy.
183                 : ;;
184         0,)
185                 # No file input but without resume parameters; catch
186                 # user error to feed us a patch from standard input
187                 # when there is already .dotest.  This is somewhat
188                 # unreliable -- stdin could be /dev/null for example
189                 # and the caller did not intend to feed us a patch but
190                 # wanted to continue unattended.
191                 tty -s
192                 ;;
193         *)
194                 false
195                 ;;
196         esac ||
197         die "previous dotest directory $dotest still exists but mbox given."
198         resume=yes
199 else
200         # Make sure we are not given --skip nor --resolved
201         test ",$skip,$resolved," = ,,, ||
202                 die "Resolve operation not in progress, we are not resuming."
204         # Start afresh.
205         mkdir -p "$dotest" || exit
207         git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
208                 rm -fr "$dotest"
209                 exit 1
210         }
212         # -b, -s, -u, -k and --whitespace flags are kept for the
213         # resuming session after a patch failure.
214         # -3 and -i can and must be given when resuming.
215         echo "$binary" >"$dotest/binary"
216         echo " $ws" >"$dotest/whitespace"
217         echo "$sign" >"$dotest/sign"
218         echo "$utf8" >"$dotest/utf8"
219         echo "$keep" >"$dotest/keep"
220         echo 1 >"$dotest/next"
221 fi
223 case "$resolved" in
224 '')
225         files=$(git diff-index --cached --name-only HEAD --) || exit
226         if [ "$files" ]; then
227            echo "Dirty index: cannot apply patches (dirty: $files)" >&2
228            exit 1
229         fi
230 esac
232 if test "$(cat "$dotest/binary")" = t
233 then
234         binary=--allow-binary-replacement
235 fi
236 if test "$(cat "$dotest/utf8")" = t
237 then
238         utf8=-u
239 else
240         utf8=-n
241 fi
242 if test "$(cat "$dotest/keep")" = t
243 then
244         keep=-k
245 fi
246 ws=`cat "$dotest/whitespace"`
247 if test "$(cat "$dotest/sign")" = t
248 then
249         SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
250                         s/>.*/>/
251                         s/^/Signed-off-by: /'
252                 `
253 else
254         SIGNOFF=
255 fi
257 last=`cat "$dotest/last"`
258 this=`cat "$dotest/next"`
259 if test "$skip" = t
260 then
261         git rerere clear
262         this=`expr "$this" + 1`
263         resume=
264 fi
266 if test "$this" -gt "$last"
267 then
268         echo Nothing to do.
269         rm -fr "$dotest"
270         exit
271 fi
273 while test "$this" -le "$last"
274 do
275         msgnum=`printf "%0${prec}d" $this`
276         next=`expr "$this" + 1`
277         test -f "$dotest/$msgnum" || {
278                 resume=
279                 go_next
280                 continue
281         }
283         # If we are not resuming, parse and extract the patch information
284         # into separate files:
285         #  - info records the authorship and title
286         #  - msg is the rest of commit log message
287         #  - patch is the patch body.
288         #
289         # When we are resuming, these files are either already prepared
290         # by the user, or the user can tell us to do so by --resolved flag.
291         case "$resume" in
292         '')
293                 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
294                         <"$dotest/$msgnum" >"$dotest/info" ||
295                         stop_here $this
297                 # skip pine's internal folder data
298                 grep '^Author: Mail System Internal Data$' \
299                         <"$dotest"/info >/dev/null &&
300                         go_next && continue
302                 test -s $dotest/patch || {
303                         echo "Patch is empty.  Was it split wrong?"
304                         stop_here $this
305                 }
306                 git stripspace < "$dotest/msg" > "$dotest/msg-clean"
307                 ;;
308         esac
310         GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
311         GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
312         GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
314         if test -z "$GIT_AUTHOR_EMAIL"
315         then
316                 echo "Patch does not have a valid e-mail address."
317                 stop_here $this
318         fi
320         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
322         SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
323         case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
325         case "$resume" in
326         '')
327             if test '' != "$SIGNOFF"
328             then
329                 LAST_SIGNED_OFF_BY=`
330                     sed -ne '/^Signed-off-by: /p' \
331                     "$dotest/msg-clean" |
332                     tail -n 1
333                 `
334                 ADD_SIGNOFF=`
335                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
336                     test '' = "$LAST_SIGNED_OFF_BY" && echo
337                     echo "$SIGNOFF"
338                 }`
339             else
340                 ADD_SIGNOFF=
341             fi
342             {
343                 printf '%s\n' "$SUBJECT"
344                 if test -s "$dotest/msg-clean"
345                 then
346                         echo
347                         cat "$dotest/msg-clean"
348                 fi
349                 if test '' != "$ADD_SIGNOFF"
350                 then
351                         echo "$ADD_SIGNOFF"
352                 fi
353             } >"$dotest/final-commit"
354             ;;
355         *)
356                 case "$resolved$interactive" in
357                 tt)
358                         # This is used only for interactive view option.
359                         git diff-index -p --cached HEAD -- >"$dotest/patch"
360                         ;;
361                 esac
362         esac
364         resume=
365         if test "$interactive" = t
366         then
367             test -t 0 ||
368             die "cannot be interactive without stdin connected to a terminal."
369             action=again
370             while test "$action" = again
371             do
372                 echo "Commit Body is:"
373                 echo "--------------------------"
374                 cat "$dotest/final-commit"
375                 echo "--------------------------"
376                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
377                 read reply
378                 case "$reply" in
379                 [yY]*) action=yes ;;
380                 [aA]*) action=yes interactive= ;;
381                 [nN]*) action=skip ;;
382                 [eE]*) git_editor "$dotest/final-commit"
383                        SUBJECT=$(reread_subject "$dotest/final-commit")
384                        action=again ;;
385                 [vV]*) action=again
386                        LESS=-S ${PAGER:-less} "$dotest/patch" ;;
387                 *)     action=again ;;
388                 esac
389             done
390         else
391             action=yes
392         fi
394         if test $action = skip
395         then
396                 go_next
397                 continue
398         fi
400         if test -x "$GIT_DIR"/hooks/applypatch-msg
401         then
402                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
403                 stop_here $this
404         fi
406         printf 'Applying %s\n' "$SUBJECT"
408         case "$resolved" in
409         '')
410                 git apply $git_apply_opt $binary --index "$dotest/patch"
411                 apply_status=$?
412                 ;;
413         t)
414                 # Resolved means the user did all the hard work, and
415                 # we do not have to do any patch application.  Just
416                 # trust what the user has in the index file and the
417                 # working tree.
418                 resolved=
419                 git diff-index --quiet --cached HEAD -- && {
420                         echo "No changes - did you forget to use 'git add'?"
421                         stop_here_user_resolve $this
422                 }
423                 unmerged=$(git ls-files -u)
424                 if test -n "$unmerged"
425                 then
426                         echo "You still have unmerged paths in your index"
427                         echo "did you forget to use 'git add'?"
428                         stop_here_user_resolve $this
429                 fi
430                 apply_status=0
431                 git rerere
432                 ;;
433         esac
435         if test $apply_status = 1 && test "$threeway" = t
436         then
437                 if (fall_back_3way)
438                 then
439                     # Applying the patch to an earlier tree and merging the
440                     # result may have produced the same tree as ours.
441                     git diff-index --quiet --cached HEAD -- && {
442                         echo No changes -- Patch already applied.
443                         go_next
444                         continue
445                     }
446                     # clear apply_status -- we have successfully merged.
447                     apply_status=0
448                 fi
449         fi
450         if test $apply_status != 0
451         then
452                 echo Patch failed at $msgnum.
453                 stop_here_user_resolve $this
454         fi
456         if test -x "$GIT_DIR"/hooks/pre-applypatch
457         then
458                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
459         fi
461         tree=$(git write-tree) &&
462         parent=$(git rev-parse --verify HEAD) &&
463         commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
464         git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
465         stop_here $this
467         if test -x "$GIT_DIR"/hooks/post-applypatch
468         then
469                 "$GIT_DIR"/hooks/post-applypatch
470         fi
472         git gc --auto
474         go_next
475 done
477 rm -fr "$dotest"